Contributing to hel
-------------------

## Versioning

I don't like go modules. They have some benefits, sure, but they have at least
one gaping maw of pain and suffering: the version path.

We are following on the heels of several other packages and only releasing
v0.x.x. This means that our version number follows the pattern
`v0.{major}.{minor}`. This also means that "minor" versions contain both new
features and bug fixes.

## Tests

I highly, highly recommend that you write a test that fails against the current
hel `main` before implementing a change to hel. Whether you are implementing a
new feature or fixing a bug, it's important to have a test that will fail if
future commits break your change.

Typically, you will start in the `mock` package, which contains all of the
logic that creates mocks.  Take a look at the tests there and create a new test
that fails against the latest and greatest `hel`.

If the `mock` package doesn't have enough information to solve your issue, you
may need to descend into the `pkg` and `typ` packages, which handle parsing and
AST logic.

## Making Your PR

Create a PR against `main`. We will cut a release after merge.

### Backports

Backporting to an old "major" version (`v0.{someOldVersion}`) is mostly
unsupported. If you _absolutely need_ a feature or bugfix backported, we can
discuss it - but you are probably better off using the `replace` directive in
your `go.mod` to point to a fork than trying to lock your `go.mod` to an old
official version.
